import uuid
import logging

from logging import Logger

from . import ifs


def __init__(params: dict) -> Logger:
    logger = Logger(uuid.uuid4().hex[20:], params['level'])
    formatter = logging.Formatter(params['logfmt'], params['datefmt'])

    if 'stream' in params['output']:
        handler = logging.StreamHandler()
        handler.setFormatter(formatter)
        logger.addHandler(handler)

    if 'file' in params['output']:
        ifs.gendir(ifs.dirname(params['handler']))
        handler = logging.FileHandler(params['handler'], encoding='UTF-8')
        handler.setFormatter(formatter)
        logger.addHandler(handler)

    return logger


sine: Logger = __init__({
    'level': 'NOTSET',
    'output': 'stream',
    'datefmt': '%Y-%m-%d %H:%M:%S',
    'logfmt': '[%(asctime)s] [%(module)s.%(funcName)s line:%(lineno)d] [%(levelname)s] %(message)s'
})

simple: Logger = __init__({
    'level': 'NOTSET',
    'output': 'stream',
    'datefmt': '%F %T',
    'logfmt': '[%(asctime)s] [%(levelname)s] %(message)s'
})
