from pymongo import MongoClient
from pymongo.database import Database

from . import idec
from . import OverFunc


@idec.TryExcept(Exception, mark='InitMongo')
@idec.Retry('InitMongo', count=10, cycle=10)
def __init__(params: dict) -> Database or MongoClient:
    db: str = params.pop('db', None)

    client = MongoClient(**params)
    OverFunc(client.close)

    return client[db] if db else client
