import paramiko

from . import idec
from . import OverFunc


@idec.TryExcept(Exception, mark='InitSSH')
@idec.Retry('InitSSH', count=10, cycle=10)
def __init__(params: dict) -> paramiko.SSHClient:
    client = paramiko.SSHClient()
    client.set_missing_host_key_policy(paramiko.AutoAddPolicy())

    for name, value in params.items():
        setattr(client, name, value)

    client.connect(**params)
    OverFunc(client.close)

    return client


def _cmd(self, command: str) -> str:
    _stdin, stdout, stderr = self.exec_command(command)
    result: bytes = stdout.read()
    assert result, f'({command}): "{stderr.read().decode().strip()}"'
    return result.decode().strip()


def _put_file(self, local: str = None, remote: str = None):
    return self.open_sftp().put(local, remote)


def _get_file(self, remote: str = None, local: str = None):
    return self.open_sftp.get(remote, local)


paramiko.SSHClient.cmd = _cmd
paramiko.SSHClient.put_file = _put_file
paramiko.SSHClient.get_file = _get_file
